<?php

/*-------------------------------------------*/
/*  PR area widget
/*-------------------------------------------*/
class WP_Widget_vkExUnit_3PR_area extends WP_Widget {

	function __construct() {
		$widget_name = vkExUnit_get_short_name(). '_' . __( '3PR area', 'vkExUnit' );

		parent::__construct(
			'WP_Widget_vkExUnit_3PR_area',
			$widget_name,
			array( 'description' => __( 'Displays a 3PR area', 'vkExUnit' ) )
		);
	}

	function form( $instance ) {
		$defaults = array(
			'label_1' => __( '3PR area1 title', 'vkExUnit' ),
			'media_3pr_image_1' => '',
			'media_3pr_alt_1' => '',
			'media_3pr_image_sp_1' => '',
			'media_3pr_alt_sp_1' => '',
			'summary_1' => '',
			'linkurl_1' => '',
			'label_2' => __( '3PR area2 title', 'vkExUnit' ),
			'media_3pr_image_2' => '',
			'media_3pr_alt_2' => '',
			'media_3pr_image_sp_2' => '',
			'media_3pr_alt_sp_2' => '',
			'summary_2' => '',
			'linkurl_2' => '',
			'label_3' => __( '3PR area3 title', 'vkExUnit' ),
			'media_3pr_image_3' => '',
			'media_3pr_alt_3' => '',
			'media_3pr_image_sp_3' => '',
			'media_3pr_alt_sp_3' => '',
			'summary_3' => '',
			'linkurl_3' => '',
		);
		$instance = wp_parse_args( (array) $instance, $defaults );

		for ( $i = 1; $i <= 3 ;) { ?>

		<h5 class="pr_subTitle"><?php echo __( '3PR area setting', 'vkExUnit' ).' '.$i; ?></h5>
        <p>
			<label for="<?php echo $this->get_field_id( 'label_'.$i );  ?>"><?php _e( 'Title:', 'vkExUnit' ); ?></label><br/>
			<input type="text" id="<?php echo $this->get_field_id( 'label_'.$i ); ?>-title" class="pr-input" name="<?php echo $this->get_field_name( 'label_'.$i ); ?>" value="<?php echo $instance['label_'.$i]; ?>" />
        </p>

		<?php // 3PR area 1 メディアアップローダー PC ?>
        <p>
			<label for="<?php echo $this->get_field_id( 'media_3pr_image_'.$i );  ?>"><?php _e( 'Select image for PC:', 'vkExUnit' ); ?></label><br/>
			<input type="hidden" class="media_image_3pr_pc <?php echo $this->get_field_id( 'media_3pr_image_'.$i );  ?>" id="<?php echo $this->get_field_id( 'media_3pr_image_'.$i ); ?>-image" name="<?php echo $this->get_field_name( 'media_3pr_image_'.$i ); ?>" value="<?php echo esc_attr( $instance['media_3pr_image_'.$i] ); ?>" />
			<input type="hidden" class="media_alt_3pr_pc" id="<?php echo $this->get_field_id( 'media_3pr_alt_'.$i ); ?>-alt" name="<?php echo $this->get_field_name( 'media_3pr_alt_'.$i ); ?>" value="<?php echo esc_attr( $instance['media_3pr_alt_'.$i] ); ?>" />
			<input type="button" class="media_select select_3pr" value="<?php _e( 'Select image', 'vkExUnit' ); ?>" onclick="clickSelect3pr(event.target);" />
			<input type="button" class="media_clear" value="<?php _e( 'Clear image', 'vkExUnit' ); ?>" onclick="clickClear3pr(event.target);" />
        </p>
        <div class="media image_3pr">
	        <?php if ( ! empty( $instance['media_3pr_image_'.$i] ) ) :  ?>
	        <img class="media_image image_3pr" src="<?php echo esc_url( $instance['media_3pr_image_'.$i] ); ?>" alt="<?php echo esc_attr( $instance['media_3pr_alt_'.$i] ); ?>" />
	        <?php endif; ?>
        </div>

        <?php // 3PR area 1 メディアアップローダー sp image ?>
        <p>
	        <label for="<?php echo $this->get_field_id( 'media_3pr_image_sp_'.$i );  ?>"><?php _e( 'Select image for Mobile:', 'vkExUnit' ); ?></label><br/>

			<input type="hidden" class="media_image_3pr_sp" id="<?php echo $this->get_field_id( 'media_3pr_image_sp_'.$i ); ?>_image" name="<?php echo $this->get_field_name( 'media_3pr_image_sp_'.$i ); ?>" value="<?php echo esc_attr( $instance['media_3pr_image_sp_'.$i] ); ?>" />

			<input type="hidden" class="media_alt_3pr_sp" id="<?php echo $this->get_field_id( 'media_3pr_alt_sp_'.$i ); ?>-alt" name="<?php echo $this->get_field_name( 'media_3pr_alt_sp_'.$i ); ?>" value="<?php echo esc_attr( $instance['media_3pr_alt_sp_'.$i] ); ?>" />

			<input type="button" class="media_select" value="<?php _e( 'Select image', 'vkExUnit' ); ?>" onclick="clickSelect3prSP(event.target);" />
			<input type="button" class="media_clear" value="<?php _e( 'Clear image', 'vkExUnit' ); ?>" onclick="clickClear3prSP(event.target);" />
        </p>
        <div class="media image_3pr_sp">
	        <?php if ( ! empty( $instance['media_3pr_image_sp_'.$i] ) ) :  ?>
	        <img class="media_image image_3pr_sp" src="<?php echo esc_url( $instance['media_3pr_image_sp_'.$i] ); ?>" alt="<?php echo esc_attr( $instance['media_3pr_alt_sp_'.$i] ); ?>" />
	        <?php endif; ?>
        </div>

		<?php // 概要テキスト ?>
		<p><label for="<?php echo $this->get_field_id( 'summary_'.$i );  ?>"><?php _e( 'Summary Text:', 'vkExUnit' ); ?></label><br/>
        </p>

		<textarea rows="4" cols="40" id="<?php echo $this->get_field_id( 'summary_'.$i ); ?>_text" class="pr_input textarea" name="<?php echo $this->get_field_name( 'summary_'.$i ); ?>"><?php echo $instance['summary_'.$i]; ?></textarea>

		<?php // リンク先_URL ?>
		<p><label for="<?php echo $this->get_field_id( 'linkurl_'.$i );  ?>"><?php _e( 'Link URL:', 'vkExUnit' ); ?></label><br/>
		<input type="text" id="<?php echo $this->get_field_id( 'linkurl_'.$i ); ?>_title" class="pr_input" name="<?php echo $this->get_field_name( 'linkurl_'.$i ); ?>" value="<?php echo $instance['linkurl_'.$i]; ?>" />
        </p>

<hr />

<?php
			$i++;
		} // for ( $i = 1; $i <= 3 ;) {

	}


	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		for ( $i = 1; $i <= 3 ;) {
			$instance['label_'.$i] = $new_instance['label_'.$i];
			$instance['media_3pr_image_'.$i] = $new_instance['media_3pr_image_'.$i];
			$instance['media_3pr_alt_'.$i] = $new_instance['media_3pr_alt_'.$i];
			$instance['media_3pr_image_sp_'.$i] = $new_instance['media_3pr_image_sp_'.$i];
			$instance['media_3pr_alt_sp_'.$i] = $new_instance['media_3pr_alt_sp_'.$i];
			$instance['summary_'.$i] = $new_instance['summary_'.$i];
			$instance['linkurl_'.$i] = $new_instance['linkurl_'.$i];
			$i++;
		}

		return $instance;
	}


	function widget( $args, $instance ) {
		echo $args['before_widget'];
		echo '<div class="veu_3prArea row">';
		for ( $i = 1; $i <= 3 ;) {

			if ( isset( $instance['label_'.$i] ) && $instance['label_'.$i] ) {
				echo '<div class="prArea col-sm-4">';

				echo '<h1 class="subSection-title">';
				if ( isset( $instance['label_'.$i] ) && $instance['label_'.$i] ) {
					echo $instance['label_'.$i];
				} else {
					_e( '3PR area', 'vkExUnit' );
				}
				echo '</h1>';

				if ( isset( $instance['media_3pr_image_'.$i], $instance['media_3pr_image_sp_'.$i] ) ) { 

					// media_pr は現在不使用 近日削除
					echo '<div class="media_pr veu_3prArea_image">';

					if ( ! empty( $instance['linkurl_'.$i] ) ) {
						echo '<a href="'.esc_url( $instance['linkurl_'.$i] ).'" class="veu_3prArea_image_link">';
					}

					if ( ! empty( $instance['media_3pr_image_'.$i] ) ) {
						$class = ( ! empty( $instance['media_3pr_image_sp_'.$i] ) ) ? ' class="image_pc"' :'';
						echo '<img'.$class.' src="'.esc_url( $instance['media_3pr_image_'.$i] ).'" alt="'.esc_attr( $instance['media_3pr_alt_'.$i] ).'" />';
					}

					if ( ! empty( $instance['media_3pr_image_sp_'.$i] ) ) {
						echo '<img class="image_sp" src="'.esc_url( $instance['media_3pr_image_sp_'.$i] ).'" alt="'.esc_attr( $instance['media_3pr_alt_sp_'.$i] ).'" />';
					}

					if ( ! empty( $instance['linkurl_'.$i] ) ) {
						echo '</a>';
					}

					echo '</div>';
				} 

				if ( ! empty( $instance['summary_'.$i] ) ) {
					echo '<p class="summary">'.nl2br( esc_attr( $instance['summary_'.$i] ) ).'</p>';
				}
				if ( ! empty( $instance['linkurl_'.$i] ) ) {
					echo '<p class="linkurl"><a href="'.esc_url( $instance['linkurl_'.$i] ).'" class="btn btn-default btn-sm">'.__( 'Read more', 'vkExUnit' ).'</a></p>';
				}

				echo '</div>';
			} // if ( isset( $instance['label_'.$i] ) && $instance['label_'.$i] ) {

			$i++;
		} // for ( $i = 1; $i <= 3 ;) {
?>
	</div>
	<?php
		echo $args['after_widget'];
	}
}
add_action( 'widgets_init', create_function( '', 'return register_widget("WP_Widget_vkExUnit_3PR_area");' ) );

// メディアアップローダーjs
function my_admin_scripts_3pr() {
	wp_enqueue_media();
	wp_register_script( 'mediauploader-3pr', plugin_dir_url( __FILE__ ) . 'js/widget-3pr-uploader.js', array( 'jquery' ), false, true );
	wp_enqueue_script( 'mediauploader-3pr' );
}
add_action( 'admin_print_scripts', 'my_admin_scripts_3pr' );

// 3PR widget CSS
function style_3PR() {
	echo '<style>
        .pr_subTitle{
            box-sizing: border-box;
            padding: 0.8em;
            width: 100%;
            border: solid 1px #ddd;
            background: #EDEDED;
            font-size: 1em;
        }
        .pr_input{
            width: 100%;
        }
        .pr_input.textarea{
            margin-top: -1em;
        }
</style>'.PHP_EOL;
}
add_action( 'admin_print_styles-widgets.php', 'style_3PR' );
